<?php

/**
 * @package    importcustomers
 * @license    GNU/GPL
*/
 
// No direct access
 
defined( '_JEXEC' ) or die( 'Restricted access' );
 
jimport('joomla.application.component.controller');
 
/**
 * Hello World Component Controller
 *
 * @package    Joomla.Tutorials
 * @subpackage Components
 */
class ImportcustomersController extends JController
{
    /**
     * Method to display the view
     *
     * @access    public
     */
    public function display()
    {
        parent::display();
    }
    
	public function upload()
	{
		jimport('joomla.filesystem.file');
      
		// Retrieve parameters of the file
		$file = JRequest::getVar('fileImport', null, 'files', 'array' );

		// Check if there was a problem uploading the file.
		if ( $file['error'] || $file['size'] < 1 )
		{
			// TODO JText + error code
			JError::raiseWarning('SOME_ERROR_CODE',  'Pb with the file' );
			return false;
		}
		
		//Clean up filename to get rid of strange characters like spaces etc
		$filename = JFile::makeSafe($file['name']);
		
		//Set up the source and destination of the file
		$src = $file['tmp_name'];
		$dest = JPATH_CACHE . DS . $filename;
		
		//First check if the file has the right extension, we need csv only
		if ( strtolower(JFile::getExt($filename) ) == 'csv') {
			if (! JFile::upload($src, $dest) ) {
				//Redirect and throw an error message
			}
		}
		else {
			//Redirect and notify user file is not right extension
			JError::raiseWarning('SOME_ERROR_CODE',  'Extension error' );
			return false;
			
		}

		
		
		// read the csv file
		$row = 1;
		$handle = fopen($dest, "r");
		
		// is there an headline ?
		$headline = JRequest::getVar('headline', null, 'post', 'int' );
		
		if ($headline) {
			$data = fgetcsv($handle, 1000, "\t");
			$row++;
		}		
		
		$number_imports_ok = 0;
		while (($data = fgetcsv($handle, 1000, "\t")) !== FALSE) {
			$model = $this->getModel('importcustomers');
			
			$model->store($data);
			if (!$model->process()) {
				JError::raiseWarning('SOME_ERROR_CODE',  'problem with the line '.$row.' containing this beginning: '.
				$data[0].' '. $data[1].' '.$data[2]);
			}
			else {
				$number_imports_ok++;
			}
			$row++;
		}
		fclose($handle);
		$msg = 'The file has been processed with ' . $number_imports_ok . ' imported.';
		$link = 'index.php?option=com_importcustomers';
		$this->setRedirect($link, $msg);
	}
 
}
