<?php
/**
 * @package    importcustomers
 * @license    GNU/GPL
 */

// No direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

// Initialize environnement
$my_path = dirname(__FILE__);

if( file_exists($my_path.DS.'..'.DS.'..'.DS.'..'.DS.'..'.DS.'configuration.php')) {
	$absolute_path = dirname( $my_path.DS.'..'.DS.'..'.DS.'..'.DS.'..'.DS.'configuration.php' );
	require_once($my_path.DS.'..'.DS.'..'.DS.'..'.DS.'..'.DS.'configuration.php');
}
else {
	die( 'Joomla Configuration File not found!' );
}

$absolute_path = realpath( $absolute_path );

global $mosConfig_absolute_path;
$mosConfig_absolute_path = str_replace(DS.'administrator', '', JPATH_BASE);
require_once($mosConfig_absolute_path.DS.'administrator'.DS.'components'.DS.'com_virtuemart'.DS.'virtuemart.cfg.php');

$mosConfig_live_site = str_replace(DS.'administrator'.DS.'components'.DS.'com_virtuemart', '', JURI::base());

require_once( CLASSPATH. '..'.DS . 'compat.joomla1.5.php' );
require_once(CLASSPATH.'..'.DS.'global.php');

require_once(CLASSPATH.'ps_userfield.php'); 

/**
 * Hello Hello Model
 *
 * @package    Joomla.Tutorials
 * @subpackage Components
 */
class ImportcustomersModelImportcustomers extends JModel
{
	var $tab_data = array();
	
	
	/**
	 * register 
	 * equivalent to the function register_save of ps_shopper
	 * @access	private
	 * @return	boolean
	 */
	private function register_save()
	{
		error_reporting(E_ALL);
    
    	// Get required system objects
    	$user           = clone(JFactory::getUser());
		$config         =& JFactory::getConfig();
		$authorize      =& JFactory::getACL();
		$document   =& JFactory::getDocument();
 
		// If user registration is not allowed, show 403 not authorized.
		$usersConfig = &JComponentHelper::getParams( 'com_users' );
		if ($usersConfig->get('allowUserRegistration') == '0') {
			JError::raiseError( 403, JText::_( 'Access Forbidden' ));
			return false;
		}
		
		// Initialize new usertype setting
		$newUsertype = $usersConfig->get( 'new_usertype' );
		if (!$newUsertype) {
			$newUsertype = 'Registered';
		}
 
		// Bind the tab_data array to the user object
		if (!$user->bind( $this->tab_data, 'usertype' )) {
 			JError::raiseError( 500, $user->getError());
		}
		
		// Set some initial user values
		$user->set('id', 0);
		$user->set( 'usertype', $newUsertype );
		$user->set('gid', $authorize->get_group_id( '', $newUsertype, 'ARO' ));

		// TODO: Should this be JDate?
		$user->set('registerDate', date('Y-m-d H:i:s'));

		// If user activation is turned on, we need to set the activation information
		$useractivation = $usersConfig->get( 'useractivation' );
		if ($useractivation == '1')
		{
			jimport('joomla.user.helper');
			$user->set('activation', md5( JUserHelper::genRandomPassword()) );
			$user->set('block', '1');
		}

		// If there was an error with registration, set the message and display form
		if ( !$user->save() )
		{
			JError::raiseWarning('', JText::_( $user->getError()));
			return false;
		}

		// Send registration confirmation mail
		$password = JRequest::getString('password', '', 'post', JREQUEST_ALLOWRAW);
		$password = preg_replace('/[\x00-\x1F\x7F]/', '', $password); //Disallow control chars in the email

		$name = $user->get('name');
		$email = $user->get('email');
		$username = $user->get('username');
		$component = 'com_user';
 
		return true;
	}
	
	/**
	 * Constructor that retrieves the ID from the request
	 *
	 * @access	public
	 * @return	void
	 */
	public function __construct()
	{
		parent::__construct();
		
		// fixed data
		
		$this->tab_data['register_account'] = 1;
		$this->tab_data['agreed'] = 1;
		$this->tab_data['remember'] = 'yes';
		$this->tab_data['Itemid'] = 53;
		$this->tab_data['gid'] = 0;
		$this->tab_data['id'] = 0;
		$this->tab_data['userid'] = 0;
		$this->tab_data['option'] = 'com_virtuemart';
		$this->tab_data['useractivation'] = 0;
		$this->tab_data['func'] = 0;
		$this->tab_data['page'] = 0;
		$this->tab_data['view'] = 0;

		
	}

	/**
	 * Method to store data
	 *
	 * @access	public
	 * @param	array (data from the reading of the csv line)
	 */
	public function store(&$data)
	{
		$this->tab_data['email'] = $data[0];
		$this->tab_data['username'] = $data[1];
		$this->tab_data['password'] = $data[2];
		$this->tab_data['password2'] = $data[3];
		$this->tab_data['company'] = $data[4];
		$this->tab_data['title'] = $data[5];
		$this->tab_data['first_name'] = $data[6];
		$this->tab_data['last_name'] = $data[7];
		$this->tab_data['middle_name'] = $data[8];
		$this->tab_data['address_1'] = $data[9];
		$this->tab_data['address_2'] = $data[10];
		$this->tab_data['city'] = $data[11];
		$this->tab_data['zip'] = $data[12];
		$this->tab_data['country'] = $data[13];
		$this->tab_data['state'] = $data[14];
		$this->tab_data['phone_1'] = $data[15];
		$this->tab_data['phone_2'] = $data[16];
		$this->tab_data['fax'] = $data[17];
		$this->tab_data['name'] = $this->tab_data['first_name'] . ' ' . $this->tab_data['last_name'];
	}
	
	/**
	 * Method to process data
	 *
	 * @access	public
	 * @return	boolean
	 */
	public function process()
	{
		$hash_secret = "VirtueMartIsCool";
		$ps_vendor_id = $_SESSION['ps_vendor_id'];
		
		$timestamp = time();
		$db = new ps_DB;
		$name = $this->tab_data['first_name'] . ' ' . $this->tab_data['last_name'];
		if( !$this->register_save() ) {
			return false;
		}
		
		$db->query("SELECT id FROM #__users WHERE username='".$this->tab_data['username']."'");
		$db->next_record();
		$uid = $db->f('id');
		
		
		if( empty( $uid )) {
			JError::raiseWarning('SOME_ERROR_CODE', 'Failed to retrieve a valid USER ID when attempting to add a new user');
			return false;
		}
		$userFields = ps_userfield::getUserFields('registration', false, '', true );
		$skipFields = ps_userfield::getSkipFields();
		
		// The first 7 fields are FIX and not built dynamically
		$fields = array( 'user_info_id' => md5(uniqid( $hash_secret)),
			'user_id' => $uid,
			'address_type' => 'BT',
			'address_type_name' => '-default-',
			'cdate' => $timestamp,
			'mdate' => $timestamp,
			'perms' => 'shopper'
		);

		foreach( $userFields as $userField ) {
			if( !in_array($userField->name, $skipFields )) {
				
				$fields[$userField->name] = ps_userfield::prepareFieldDataSave( $userField->type, $userField->name, vmGet($this->tab_data, $userField->name, strtoupper($userField->name) ) );

				// Catch a newsletter registration!
				if( stristr( $userField->params, 'newsletter' )) {
					if( !empty($this->tab_data[$userField->name])) {
						require_once( CLASSPATH.'parameters.class.php');
						$subscribeTo = new vmParameters( $userField->params );
					}
				}

			}
		}
		$fields['user_email'] = $fields['email'];
		unset($fields['email']);

		$db->buildQuery('INSERT', '#__{vm}_user_info', $fields );

		// Run the query now!
		if (!$db->query()) {
			JError::raiseWarning('SOME_ERROR_CODE', 'Failed for first insert '.$q);
			return false;
		}

		// Insert vendor relationship
		$q = "INSERT INTO #__{vm}_auth_user_vendor (user_id,vendor_id)";
		$q .= " VALUES ";
		$q .= "(" . $uid . ",";
		$q .= $ps_vendor_id . ") ";
		if (!$db->query($q)) {
			JError::raiseWarning('SOME_ERROR_CODE', 'Failed for vendor relationship '.$q);
			return false;
		}
		

		$q =  "SELECT shopper_group_id from #__{vm}_shopper_group WHERE ";
		$q .= "`default`='1' ";
		
		$db->query($q);
		if (!$db->num_rows()) {  // take the first in the table
			
			$q =  "SELECT shopper_group_id from #__{vm}_shopper_group";
			$db->query($q);
		}
		$db->next_record();
		$this->tab_data['shopper_group_id'] = $db->f("shopper_group_id");
		
		$customer_nr = uniqid( rand() );
		// Insert Shopper -ShopperGroup - Relationship
		$q  = "INSERT INTO #__{vm}_shopper_vendor_xref ";
		$q .= "(user_id,vendor_id,shopper_group_id,customer_number) ";
		$q .= "VALUES ($uid, $ps_vendor_id,".$this->tab_data['shopper_group_id'].", '$customer_nr')";
		if (!$db->query($q)) {
			JError::raiseWarning('SOME_ERROR_CODE', 'Failed for shopper group '.$q);
			return false;
		}
		
		return true;
	}
	
	
}
